import 'package:flutter/material.dart';
import 'package:htkc_utils/htkc_utils.dart';

class CustomAlertDialog extends StatefulWidget {
  final Widget child;
  final Function? function;

  const CustomAlertDialog({Key? key, required this.child, this.function}) : super(key: key);
  @override
  CustomAlertDialogState createState() => CustomAlertDialogState();
}

class CustomAlertDialogState extends State<CustomAlertDialog> {
  @override
  void initState() {
    widget.function;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return openAlertDialog();
  }

  openAlertDialog() {
    return StatefulBuilder(builder: (context, setState) {
      return AlertDialog(
        shape: roundedRectangleShape,
        content: SingleChildScrollView(
          child: widget.child,
        ),
      );
    });
  }
}
